<script setup lang="ts">
import { ref } from "vue";
import jwt_decode from "jwt-decode";

definePageMeta({
  middleware: "authentication",
});

// Récupération des droits :
const tokenCookie = useCookie("aei-desktop-token");
const decodedToken = jwt_decode(tokenCookie.value);
const currentEmployerId = decodedToken.employerId;

const { baseURL } = useRuntimeConfig().app;
const authorizationHeader = useAuthorizationHeader("application/json");

// Récupération des interventions :
/**
 * Renvoie l'URL pour récupérer les interventions
 * en fonction de l'utilisateur.
 * @param {Array} roles les rôles.
 * @param {number} userId l'identifiant de l'utilisateur.
 * @returns {string} l'URL pour récupérer les interventions.
 */
function getFetchInterventionsURL(
  roles: Array,
  userId: number,
  employerId: number
): string {
  if (roles.includes("ROLE_READ_EMPLOYER_INTERVENTIONS")) {
    return (
      baseURL +
      "api/employers/" +
      employerId +
      "/interventions?order[id]=desc&status.slug="
    );
  }

  return "";
}

const { data: responseInterventions } = await useFetch(
  getFetchInterventionsURL(
    decodedToken.roles,
    decodedToken.userId,
    decodedToken.employerId
  ),
  {
    headers: authorizationHeader,
  }
);
const interventions = ref(responseInterventions.value.interventions);

const { data: status } = await useFetch(baseURL + "api/status", {
  headers: authorizationHeader,
});

const { data: categories } = await useFetch(baseURL + "api/categories", {
  headers: authorizationHeader,
});

const { data: priorities } = await useFetch(baseURL + "api/priorities", {
  headers: authorizationHeader,
});

const { data: participants } = await useFetch(
  baseURL + `api/employers/${currentEmployerId}/active-agents`,
  {
    headers: authorizationHeader,
  }
);

const tableHeaders = [
  "ID",
  "Adresse",
  "Catégorie",
  "Priorité",
  "Statut",
  "Création",
  "Agents",
  "",
];

// NAV
const filterNav = ref("all");
const filteredInterventions = ref([]);
const selectedStatus = ref([]);
const selectedCategories = ref([]);
const selectedPriorities = ref([]);
const selectedParticipants = ref([]);

function filterInterventionsNav() {
  const today = new Date();

  switch (filterNav.value) {
    case "day":
      filteredInterventions.value = interventions.value.filter(
        (intervention) => {
          const interventionDate = new Date(intervention.createdAt);
          return interventionDate.toDateString() === today.toDateString();
        }
      );
      break;
    case "week":
      const startOfWeek = new Date(today);
      startOfWeek.setDate(today.getDate() - today.getDay());
      const endOfWeek = new Date(today);
      endOfWeek.setDate(today.getDate() + (6 - today.getDay()));
      filteredInterventions.value = interventions.value.filter(
        (intervention) => {
          const interventionDate = new Date(intervention.createdAt);
          return (
            interventionDate >= startOfWeek && interventionDate <= endOfWeek
          );
        }
      );
      break;
    case "month":
      filteredInterventions.value = interventions.value.filter(
        (intervention) => {
          const interventionDate = new Date(intervention.createdAt);
          return (
            interventionDate.getMonth() === today.getMonth() &&
            interventionDate.getFullYear() === today.getFullYear()
          );
        }
      );
      break;
    default:
      filteredInterventions.value = interventions.value;
  }
}

function handleFilterChangeNav(value) {
  filterNav.value = value;
  filterInterventionsNav();
}

onMounted(() => {
  filterInterventionsNav();
});

const buttonsFiltre = [
  { id: "menu1", label: "Statut" },
  { id: "menu2", label: "Catégorie" },
  { id: "menu3", label: "Priorité" },
  { id: "menu4", label: "Agent" },
];

const toggleMenu = (menuId) => {
  const menu = document.getElementById("menu" + menuId);
  const menus = document.getElementsByClassName("menu");

  for (let i = 0; i < menus.length; i++) {
    if (menus[i].id !== "menu" + menuId) {
      menus[i].classList.remove("show");
    }
  }

  menu.classList.toggle("show");
};

const getInitials = (agent) => {
  const firstnameInitial = agent.firstname.charAt(0).toUpperCase();
  const lastnameInitial = agent.lastname.charAt(0).toUpperCase();
  return `${firstnameInitial}${lastnameInitial}`;
};
</script>

<template>
  <SubHeader> Interventions </SubHeader>
  <section class="fr-p-2w body">
    <div>
      <Nav
        :filterInterventionsNav="filterInterventionsNav"
        @filter="handleFilterChangeNav"
        :filter="filterNav"
      />
      <!-- <section class="fr-py-3w fr-px-2w section-filtre">
        <div class="fr-grid-row fr-mt-2w">
          <div
            v-for="button in buttonsFiltre"
            :key="button.id"
            class="fr-mr-2w button-filtre-list"
          >
            <button
              class="fr-p-1w button-filtre"
              @click="toggleMenu(button.id)"
            >
              {{ button.label }}
              <span class="fr-icon-arrow-down-s-line" aria-hidden="true"></span>
            </button>
            <div :id="'menu' + button.id" class="menu">
              <div
                class="fr-checkbox-group fr-p-2w"
                v-if="button.id === 'menu1'"
                v-for="(statut, index) in status"
              >
                <input
                  :name="`checkboxes-status-${statut.id}`"
                  :id="`checkboxes-status-${statut.id}`"
                  type="checkbox"
                />
                <label class="fr-label" :for="`checkboxes-${statut.id}`">{{
                  statut.name
                }}</label>
              </div>

              <div
                class="fr-checkbox-group fr-p-2w"
                v-else-if="button.id === 'menu2'"
                v-for="category in categories"
              >
                <input
                  :name="`checkboxes-category-${category.id}`"
                  :id="`checkboxes-category-${category.id}`"
                  type="checkbox"
                />
                <label
                  class="fr-label"
                  :for="`checkboxes-category-${category.id}`"
                  >{{ category.name }}</label
                >
              </div>
              <div
                class="fr-checkbox-group fr-p-2w"
                v-else-if="button.id === 'menu3'"
                v-for="priority in priorities"
              >
                <input
                  :name="`checkboxes-priority-${priority.id}`"
                  :id="`checkboxes-priority-${priority.id}`"
                  type="checkbox"
                />
                <label
                  class="fr-label"
                  :for="`checkboxes-priority-${priority.id}`"
                  >{{ priority.name }}</label
                >
              </div>
              <div
                class="fr-checkbox-group fr-p-2w"
                v-else-if="button.id === 'menu4'"
                v-for="participant in participants"
              >
                <input
                  :name="`checkboxes-participant-${participant.id}`"
                  :id="`checkboxes-participant-${participant.id}`"
                  type="checkbox"
                />
                <label
                  class="fr-label"
                  :for="`checkboxes-participant-${participant.id}`"
                  >{{ participant.firstname }} {{ participant.lastname }}</label
                >
              </div>
            </div>
          </div>
        </div>
      </section> -->
      <section>
        <section class="fr-table fr-col-12 table-container">
          <Table :headers="tableHeaders" :entities="filteredInterventions">
            <template #table-body="entity">
              <td class="td-border-bottom">#{{ entity.id }}</td>
              <td class="td-border-bottom">
                {{ entity.location.rest }}
                {{ entity.location.street }}
                {{ entity.location.postcode }}
                {{ entity.location.city }}
              </td>
              <td class="td-border-bottom">{{ entity.category.name }}</td>
              <td class="td-border-bottom">
                <p
                  :class="[
                    'fr-tag',
                    { urgent: entity.priority.slug === 'urgent' },
                  ]"
                >
                  {{ entity.priority.name }}
                </p>
              </td>
              <td class="td-border-bottom">
                <p
                  :class="[
                    'fr-badge fr-badge--no-icon',
                    {
                      'fr-badge--new': entity.status.name === 'À faire',
                      'fr-badge--info': entity.status.name === 'En cours',
                      'fr-badge--warning': entity.status.name === 'Bloquée',
                      'fr-badge--error': entity.status.name === 'Annulée',
                      'fr-badge--success': entity.status.name === 'Terminée',
                    },
                  ]"
                >
                  {{ entity.status.name }}
                </p>
              </td>
              <td class="td-border-bottom">
                {{ useFormatDateDigit(entity.createdAt) }}
              </td>
              <td class="td-border-bottom">
                <div class="fr-grid-row avatar-container">
                  <div
                    class="fr-ml-1w agent-avatar"
                    v-for="agent in entity.participants"
                  >
                    <img
                      v-if="agent.picture"
                      :src="agent.picture"
                      class="agent-photo"
                      :alt="`Photo de ${agent.firstname} ${agent.lastname}`"
                    />
                    <div v-else class="agent-initials">
                      {{ getInitials(agent) }}
                    </div>
                  </div>
                </div>
              </td>
            </template>
          </Table>
        </section>
      </section>
    </div>
  </section>
</template>

<style scoped>
.section-filtre,
.button-filtre {
  border: 1px solid var(--border-default-grey);
  border-radius: 8px;
  background-color: var(--background-default-grey);
}

.button-filtre-list {
  position: relative;
}

.menu {
  display: none;
  position: absolute;
  background-color: var(--background-default-grey);
  border: 1px solid var(--border-default-grey);
  border-radius: 8px;
  top: calc(100% + 10px);
  left: 0;
  z-index: 1;
}

.menu.show {
  display: block;
}

.fr-tag {
  background-color: var(--background-action-low-blue-france);
  color: var(--text-action-high-blue-france);
}

.urgent {
  background-color: var(--background-contrast-warning);
  color: var(--text-action-high-purple-glycine);
}

li {
  list-style: none;
}

.table-container {
  height: calc(100vh - var(--height-top-bar) - 148px);
}

.agent-initials {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  width: 38px;
  height: 38px;
  line-height: 38px;
  text-align: center;
  font-weight: bold;
  font-size: 16px;
  background-color: var(--blue-france-925-125);
  color: var(--blue-france-sun-113-625);
  border-radius: 50%;
  border: 1px solid var(--background-default-grey);
}
.agent-avatar {
  position: relative;
  width: 38px;
  height: 38px;
}

.agent-photo {
  position: absolute;
  top: 0;
  left: 0;
  width: 38px;
  height: 38px;
  border-radius: 50%;
  border: 1px solid var(--background-default-grey);
}
</style>
